/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rpn;

import java.util.Deque;
import java.util.LinkedList;
import java.util.Scanner;

/**
 *
 * @author thanh
 */
public class RPNCalculator {

    public static final int ROWS = 4;
    public static final int COLS = 8;
    public static final int NUMBER_OF_REGISTERS = 10;
    protected Deque<Double> theStack;
    protected LinkedList<String> instructions;
    protected double[] registers;
    public static final int BINARY = 2;

    /**
     * Creates a new instance of RPNCalculator
     */
    public RPNCalculator() {
        theStack = new LinkedList<Double>();
        registers = new double[NUMBER_OF_REGISTERS];
        instructions = new LinkedList<String>();
    }

    public String binaryOperation() {
        return theStack.pop() + " " + theStack.pop();
    }

    public boolean testBinary() {
        return theStack.size() >= BINARY;
    }

    public double add() {
        String aString = "";
        if (testBinary()) {
            aString = binaryOperation();
        }
        Scanner in = new Scanner(aString);
        double first = in.nextDouble();
        double second = in.nextDouble();
        theStack.push(first + second);
        return first + second;
    }

    public double subtract() {
        String aString = "";
        if (testBinary()) {
            aString = binaryOperation();
        }
        Scanner in = new Scanner(aString);
        double first = in.nextDouble();
        double second = in.nextDouble();
        theStack.push(second - first);
        return second - first;
    }

    public double multiply() {
        String aString = "";
        if (testBinary()) {
            aString = binaryOperation();
        }
        Scanner in = new Scanner(aString);
        double first = in.nextDouble();
        double second = in.nextDouble();
        theStack.push(first * second);
        return first * second;
    }

    public double divide() {
        String aString = "";
        if (testBinary()) {
            aString = binaryOperation();
        }
        Scanner in = new Scanner(aString);
        double first = in.nextDouble();
        double second = in.nextDouble();
        theStack.push(second / first);
        return second / first;
    }

    public double modOperator() {
        String aString = "";
        if (testBinary()) {
            aString = binaryOperation();
        }
        Scanner in = new Scanner(aString);
        double first = in.nextDouble();
        double second = in.nextDouble();
        theStack.push(second % first);
        return second % first;
    }

    public double exponentiation() {
        String aString = "";
        if (testBinary()) {
            aString = binaryOperation();
        }
        Scanner in = new Scanner(aString);
        double first = in.nextDouble();
        double second = in.nextDouble();
        theStack.push(Math.pow(second, first));
        return Math.pow(second, first);
    }

    public void up() {
        double last = theStack.pop();
        theStack.addLast(last);
    }

    public void down() {
        double first = theStack.pollLast();
        theStack.push(first);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
    }

}
